# SimpleKeyingInterface Class Reference

`#include <cryptlib.h>`

Inheritance diagram for SimpleKeyingInterface:

List of all members.

## Detailed Description

keying interface for crypto algorithms that take byte strings as keys

Definition at line 354 of file cryptlib.h.

## Public Types
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
## Public Member Functions
virtual size_t | MinKeyLength () const =0
| returns smallest valid key length in bytes */
virtual size_t | MaxKeyLength () const =0
| returns largest valid key length in bytes */
virtual size_t | DefaultKeyLength () const =0
| returns default (recommended) key length in bytes */
virtual size_t | GetValidKeyLength (size_t n) const =0
| returns the smallest valid key length in bytes that is >= min(n, GetMaxKeyLength())
virtual bool | IsValidKeyLength (size_t n) const
| returns whether n is a valid key length
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| set or reset the key of this object
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| calls SetKey() with an NameValuePairs object that just specifies "Rounds"
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| calls SetKey() with an NameValuePairs object that just specifies "IV"
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| calls SetKey() with an NameValuePairs object that just specifies "IV"
virtual IV_Requirement | IVRequirement () const =0
| returns the minimal requirement for secure IVs
bool | IsResynchronizable () const
| returns whether this object can be resynchronized (i.e. supports initialization vectors)
bool | CanUseRandomIVs () const
| returns whether this object can use random IVs (in addition to ones returned by GetNextIV)
bool | CanUsePredictableIVs () const
| returns whether this object can use random but possibly predictable IVs (in addition to ones returned by GetNextIV)
bool | CanUseStructuredIVs () const
| returns whether this object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV)
virtual unsigned int | IVSize () const
unsigned int | DefaultIVLength () const
| returns default length of IVs accepted by this object
virtual unsigned int | MinIVLength () const
| returns minimal length of IVs accepted by this object
virtual unsigned int | MaxIVLength () const
| returns maximal length of IVs accepted by this object
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| resynchronize with an IV. ivLength=-1 means use IVSize()
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *IV)
| get a secure IV for the next message
## Protected Member Functions
virtual const Algorithm & | GetAlgorithm () const =0
virtual void | UncheckedSetKey (const byte *key, unsigned int length, const NameValuePairs &params)=0
void | ThrowIfInvalidKeyLength (size_t length)
void | ThrowIfResynchronizable ()
void | ThrowIfInvalidIV (const byte *iv)
size_t | ThrowIfInvalidIVLength (int size)
const byte * | GetIVAndThrowIfInvalid (const NameValuePairs &params, size_t &size)
void | AssertValidKeyLength (size_t length) const

## Member Function Documentation

void SimpleKeyingInterface::SetKey | ( | const byte * | key,
|  | size_t | length,
|  | const NameValuePairs & | params = `g_nullNameValuePairs` |
| ) |  |  | `[virtual]`

set or reset the key of this object

Parameters:

  | params | is used to specify Rounds, BlockSize, etc.

Reimplemented in AuthenticatedSymmetricCipherBase.

Definition at line 53 of file cryptlib.cpp.

Referenced by SetKeyWithIV(), and SetKeyWithRounds().

bool SimpleKeyingInterface::IsResynchronizable | ( |  | ) | const`[inline]`

returns whether this object can be resynchronized (i.e. supports initialization vectors)

If this function returns true, and no IV is passed to SetKey() and CanUseStructuredIVs()==true, an IV of all 0's will be assumed.

Definition at line 393 of file cryptlib.h.

void SimpleKeyingInterface::GetNextIV | ( | RandomNumberGenerator & | rng,
|  | byte * | IV |
| ) |  |  | `[virtual]`

get a secure IV for the next message

This method should be called after you finish encrypting one message and are ready to start the next one. After calling it, you must call SetKey() or Resynchronize() before using this object again. This method is not implemented on decryption objects.

Definition at line 129 of file cryptlib.cpp.

References RandomNumberGenerator::GenerateBlock().

The documentation for this class was generated from the following files:

- cryptlib.h
- cryptlib.cpp